#define RF69_COMPAT 1
#include <JeeLib.h>

#define RF_freq RF12_433MHZ
const int nodeID = 30;
const int networkGroup = 210;
const byte LED = 9;
const byte PULSE = 3;

unsigned long intervalMillis=5000; // the time we need to wait
unsigned long previousMillis=0; // millis() returns an unsigned long.

typedef struct {
  unsigned long pulses;    
  unsigned long uptime;     
//  unsigned long timecheck;  
//  unsigned long lastSent;                                       
} Payload;
Payload node;

// Interrupt Service Routine (ISR)
void onPulse () {
  if (digitalRead (PULSE) == LOW) {
    digitalWrite (LED, LOW);
    Serial.print("on ");
    node.pulses++;
    Serial.println(node.pulses);
  } else {
    digitalWrite (LED, HIGH);
    Serial.println("off");
  }
}  // end of onPulse

void setup () { 
  Serial.begin(38400);
  pinMode (LED, OUTPUT);                  // so we can update the LED
  digitalWrite (PULSE, HIGH);             // internal pull-up resistor
  attachInterrupt (1, onPulse, CHANGE);   // attach interrupt handler
  rf12_initialize(nodeID, RF_freq, networkGroup);
}  // end of setup

void loop () {
  if (timecheck()) {
//    node.timecheck = previousMillis;
//    node.lastSent = lastSent;
    node.uptime = millis();
    rf12_sendNow(0, &node, sizeof node);
  }
} 

boolean timecheck () {
  unsigned long currentMillis = millis(); // grab current 
  if ((unsigned long)(currentMillis - previousMillis) >= intervalMillis) {
    previousMillis = currentMillis;
    return true;
  } else {
    return false;
  }
}


